;
; win32help.ahk - ver 0.05 (2007/06/12)
;   Script making win32 API wrapper for AutoHotkey
;   Written by Yak!
;
;   $URL: https://yak.myhome.cx/repos/source/myusr/trunk/win32help.ahk $
;   $Date: 2007-06-15 09:42:17 +0900 (Fri, 15 Jun 2007) $
;   $Rev: 394 $
;

;#NoTrayIcon

Gui, Add, Radio, x36 y7 w110 h20 gSimpleConstants, SimpleCo&nstants
Gui, Add, Radio, x166 y7 w80 h20 gConstants, &Constants
Gui, Add, Radio, x266 y7 w80 h20 gFunctions, &Functions
Gui, Add, Radio, x366 y7 w80 h20 gStruct, &Struct
Gui, Add, Text, x16 y37 w60 h20 vtypelabel, &Type:
Gui, Add, Edit, x86 y37 w290 h20 r1 vtype, 
Gui, Add, Text, x16 y67 w60 h20 vprefixlabel, &Prefix:
Gui, Add, Edit, x86 y67 w290 h20 r1 vprefix, 
Gui, Add, Text, x16 y97 w60 h20 vfieldslabel, &Fi&elds:
Gui, Add, Edit, x86 y97 w370 h20 r1 vfields, 
Gui, Add, Text, x16 y127 w60 h20 , &Output:
Gui, Add, Edit, x86 y127 w290 h20 r1 voutput, 
Gui, Add, Button, x386 y127 w70 h30 gBrowse, &Browse
Gui, Add, Text, x16 y157 w60 h20 vcompilerlabel, Co&mpiler:
Gui, Add, Edit, x86 y157 w290 h20 r1 vcompiler, g++ -o `%exe`% -mno-cygwin `%input`%
Gui, Add, Text, x16 y187 w60 h20 vheaderslabel, &Headers:
Gui, Add, Edit, x86 y187 w370 h20 r1 vheaders, windows.h
Gui, Add, Text, x16 y217 w60 h20 , &Definition:
Gui, Add, Edit, x16 y237 w440 h110 vdefinition, Paste definitions here`n`nThis script is written by Yak! (http://yak.myhome.cx/junks/)
Gui, Add, Button, x36 y357 w100 h30 vparse gParse, P&arse
Gui, Add, Button, x176 y357 w100 h30 gGo, &Go
Gui, Add, Button, x316 y357 w100 h30 gQuit, &Quit
; Generated using SmartGUI Creator 4.0
Gui, Show, h400 w480, Win32 API Helper - Ver 0.05 (2007/06/12)
GuiControl, , Button1, 1
GoSub, SimpleConstants
Return

SetInputMode:
GuiControl, Enable%inputmode4type%, typelabel
GuiControl, Enable%inputmode4type%, type
GuiControl, Enable%inputmode4type%, prefixlabel
GuiControl, Enable%inputmode4type%, prefix
GuiControl, Enable%inputmode4compiler%, fieldslabel
GuiControl, Enable%inputmode4compiler%, fields
GuiControl, Enable%inputmode4compiler%, compilerlabel
GuiControl, Enable%inputmode4compiler%, compiler
GuiControl, Enable%inputmode4compiler%, headerslabel
GuiControl, Enable%inputmode4compiler%, headers
GuiControl, Enable%inputmode4compiler%, parse
Return

SimpleConstants:
mode=SimpleConstants
inputmode4type=0
inputmode4compiler=0
GoSub, SetInputMode
Return

Constants:
mode=Constants
inputmode4type=0
inputmode4compiler=1
GoSub, SetInputMode
Return

Functions:
mode=Functions
inputmode4type=0
inputmode4compiler=0
GoSub, SetInputMode
Return

Struct:
mode=Struct
inputmode4type=1
inputmode4compiler=1
GoSub, SetInputMode
Return

Browse:
FileSelectFile, out, S16
GuiControl, , output, %out%
Return

Parse:
If mode = Struct
    Goto, ParseStruct
If mode = Constants
    Goto, ParseConstants
Return

ParseStruct:
Gui, Submit, NoHide
mydefinition:=RegExReplace(definition, "//.*?$|/\*.*?\*/")
RegExMatch(mydefinition, "[},]\s*(\w\S*?)[,;]", mytype)
GuiControl, , type, %mytype1%
RegExMatch(mydefinition, "{\s*(.*;)\s*}", myfields)
myfields=
Loop, Parse, myfields1, `;
{
    RegExMatch(A_LoopField, "(\w+)\s*$", myfield)
    myfields=%myfields% %myfield1%
}
GuiControl, , fields, %myfields%
Return

ParseConstants:
Gui, Submit, NoHide
mydefinition:=RegExReplace(definition, "//.*?$|/\*.*?\*/")
myfields=
Loop, Parse, mydefinition, `r`n
{
    If (RegExMatch(A_LoopField, "^#\s*define\s*(\S+)", myfield))
        myfields=%myfields% %myfield1%
}
GuiControl, , fields, %myfields%
Return

Go:
Gui, Submit, NoHide
If output =
{
    MsgBox, output field is blank
    Return
}
If mode = Struct
    Goto, GoStruct
If mode = SimpleConstants
    Goto, GoSimpleConstants
If mode = Constants
    Goto, GoConstants
If mode = Functions
    Goto, GoFunctions
Return

GoStruct:
If fields =
{
    MsgBox, fields field is blank
    Return
}
If prefix =
{
    MsgBox, prefix field is blank
    Return
}
If type =
{
    MsgBox, type field is blank
    Return
}
If compiler =
{
    MsgBox, compiler field is blank
    Return
}
If headers =
{
    MsgBox, headers field is blank
    Return
}
content=
( Join`r`n

void output(char* prefix, char* name, size_t offset, size_t size, bool is_integer, bool is_signed, bool is_pointer)
{
    if(is_integer || is_pointer) {
        cout << "Get_" << prefix << "_" << name << "(ByRef source)\n"
                "{\n"
                "    return ExtractInteger(source, " << offset << ", " << (is_signed ? "true" : "false") << ", " << size << ")\n"
                "}\n"
                "Set_" << prefix << "_" << name << "(ByRef source, content)\n"
                "{\n"
                "    InsertInteger(content, source, " << offset << ", " << size << ")\n"
                "}\n";
    } else {
        cout << "Get_" << prefix << "_" << name << "(ByRef source, ByRef dest)\n"
                "{\n"
                "    CopyMemory(&dest, &source + " << offset << ", " << size << ")\n"
                "}\n"
                "Set_" << prefix << "_" << name << "(ByRef source, ByRef content)\n"
                "{\n"
                "    CopyMemory(&source + " << offset << ", &content, " << size << ")\n"
                "}\n";
    }
}

template<typename T>
bool is_int(T) { return numeric_limits<T>::is_integer; }

template<typename T>
bool is_sign(T) { return numeric_limits<T>::is_signed; }

template<typename T>
struct IsPointer { const static bool value = false; };

template<typename T>
struct IsPointer<T*> { const static bool value = true; };

template<typename T>
bool is_pointer(T) { return IsPointer<T>::value; }

int main(void)
{
    %type% obj;
    cout <<
        "Init_%prefix%(ByRef source)\n"
        "{\n"
        "    VarSetCapacity(source, " << sizeof(obj) << ", 0)\n"
)
sizes=
Loop
{
    IniRead, size, win32help.ini, size, %A_Index%
    If size = ERROR
        Break
    Else
    {
		If sizes
			sizes=%sizes%|%size%
		Else
			sizes=%size%
    }
}
StringSplit, field, fields, %A_Tab%%A_Space%
If(RegExMatch(field1, "^(" . sizes . ")$"))
{
    content=%content%        "    Set_%prefix%_%field1%(source, " << sizeof(obj) << ")\n"
}
content=%content%
( Join`r`n
        "}\n";
)
Loop, Parse, fields, %A_Tab%%A_Space%
{
    If(RegExMatch(A_LoopField, "^\s*$"))
        Continue
    content=%content%`r`n    output("%prefix%", "%A_LoopField%", offsetof(%type%, %A_LoopField%), sizeof(obj.%A_LoopField%), is_int(obj.%A_LoopField%), is_sign(obj.%A_LoopField%), is_pointer(obj.%A_LoopField%))`;`r`n
}
GoTo, GoCompile

GoCompile:
content=
( Join`r`n
#include <cstdlib>
#include <iostream>
#include <limits>

using namespace std;

)`r`n%content%`r`n
( Join`r`n
    cout << endl;
    return 0;
}

)
Loop, Parse, headers, %A_Space%%A_Tab%
{
    content=#include <%A_LoopField%>`r`n%content%
}
content=#define WINVER 0x0600`r`n%content%
input=temp.cpp
exe=temp.exe
IfExist, %output%
    FileDelete, %output%
IfExist, %input%
    FileDelete, %input%

FileAppend, %content%, %input%
Transform, compile, Deref, %compiler%
RunWait, %compile%
If ErrorLevel
{
    MsgBox, error occurred in compilation, plaese check %input% file.
    Return
}
RunWait, %comspec% /c %exe% >%output%

IfExist, %input%
    FileDelete, %input%
IfExist, %exe%
    FileDelete, %exe%

If output = CLIP
{
    IfExist, %output%
    {
        FileRead, Clipboard, %output%
        FileDelete, %output%
    }
}
Return

GoSimpleConstants:
constants:=RegExReplace(definition, "//.*?$|/\*.*?\*/")
constants:=RegExReplace(constants, "`am)^#define\s+(\S+)\s+(.*?)$", "$1=$2")
If output = CLIP
    Clipboard=%constants%
Else
{
    IfExist, %output%
        FileDelete, %output%
    FileAppend, %constants%, %output%
}
Return

GoConstants:
If fields =
{
    MsgBox, fields field is blank
    Return
}
If compiler =
{
    MsgBox, compiler field is blank
    Return
}
If headers =
{
    MsgBox, headers field is blank
    Return
}
content=int main(void)`r`n{`r`n
Loop, Parse, fields, %A_Tab%%A_Space%
{
    If(RegExMatch(A_LoopField, "^\s*$"))
        Continue
    content=%content%    cout << "%A_LoopField%=" << %A_LoopField% << '\n';`r`n
}
GoTo, GoCompile

AddAssume(key)
{
    global assume

    If(RegExMatch(assume, "\b" . key . "\b") == 0)
        assume=%assume% %key%
}


ScalarTypeGuess(key)
{
    IniRead, map, win32help.ini, map, %key%
    If(map = "ERROR" and RegExMatch(key, "^H[^_]+$"))
    {
        AddAssume(key)
        map=UInt
    }
    return map
}

GoFunctions:
assume=
result=
ignores=
content:=RegExReplace(definition, "//.*?[`r`n]|/\*.*?\*/", " ")
Loop
{
    IniRead, ignore, win32help.ini, ignore, %A_Index%
    If ignore = ERROR
        Break
    Else
    {
        If ignores
            ignore=%ignore%
        Else
            ignores=%ignores%|%ignore%
    }
}
If ignores
{
    ignores=\b(%ignores%)\b
    content:=RegExReplace(content, ignores)
}
Loop, Parse, content, `;
{
    RegExMatch(A_LoopField, "^\s*(.*\S)\s+(\w+)\s*\((.*)\)", field)
    If(field1 = "void" or field1 = "VOID")
        returntype=UInt
    Else
        If (RegExMatch(field1, "WINAPIV|_*cdecl"))
        {
            cdecl=true
            field1:=RegExReplace(field1, "\s*(WINAPIV|_*cdecl)\s*")
        } Else
            cdecl=false
        returntype:=ScalarTypeGuess(field1)
        If returntype = ERROR
        {
            AddAssume(field1)
            returntype=UInt
        }
        If cdecl = true
            returntype=Cdecl %returntype%
    If field2
    {
        funcname=%field2%
        If(field3 = "" or field3 = "void")
            type=0
        Else
            Loop, Parse, field3, `,
            {
                origkey:=RegExReplace(A_LoopField, "\s+((?:\S+)(?:\s*\*)*)*.*", "$1")
                origkey:=RegExReplace(origkey, "\s+")
                key:=RegExReplace(origkey, "^L?P", "P")
                map:=ScalarTypeGuess(key)
                If(map = "ERROR" and RegExMatch(key, "^P|\*$"))
                {
                    key2:=RegExReplace(key, "^P|\*$", "", "", 1)
                    map:=ScalarTypeGuess(key2)
                    If map = ERROR
                    {
                        AddAssume(origkey)
                        map=UInt
                    } Else
                        map=%map%*
                }
                If map = ERROR
                {
                    InputBox, map, Query DllCall type, Input DllCall type for %key%
                    If ErrorLevel = 0
                        IniWrite, %map%, win32help.ini, map, %key%
                }
                type%A_Index%=%map%
                type=%A_Index%
            }
        result=%result%%funcname%(
        Loop, %type%
        {
            If A_Index <> 1
                result:=result . "," . A_Space
            If(RegExMatch(type%A_Index%, "^\s*[Ss][Tt][Rr]\s*$|[pP*]\s*$"))
                result:=result . "ByRef "
            result=%result%arg%A_Index%
        }
        result=%result%)`n{`n`treturn DllCall("%funcname%"
        Loop, %type%
        {
            map:=type%A_Index%
            if map = CStr
                map=Str
            result=%result%`, "%map%"`, arg%A_Index%
        }
        result=%result%, "%returntype%")`n}`n
    }
}
If assume
    MsgBox, 4, Confirmation, The following types are guessed as UInt.`n`n%assume%`n`nDo you need to override them?
IfMsgBox, Yes
{
    Loop, Parse, assume, %A_Space%
    {
        InputBox, map, Query DllCall type, Input DllCall type mapping, , 250, 100, , , , , %A_LoopField%=UInt
        If ErrorLevel = 0
        {
            StringSplit, element, map, =
            IniWrite, %element2%, win32help.ini, map, %element1%
        }
    }
    GoTo, GoFunctions
}
If output = CLIP
    Clipboard=%result%
Else
{
    IfExist, %output%
        FileDelete, %output%
    FileAppend, %result%, %output%
}
Return

Quit:
GuiClose:
ExitApp
